--- old/usr/src/lib/pkcs11/pkcs11_kernel/common/kernelKeys.c	Fri Jul  6 15:55:05 2018
+++ new/usr/src/lib/pkcs11/pkcs11_kernel/common/kernelKeys.c	Fri Jul  6 15:55:05 2018
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2018, Joyent, Inc.
  */
 
 #include <strings.h>
@@ -343,21 +344,15 @@
 	}
 	new_objp->is_lib_obj = B_TRUE;
 	new_objp->session_handle = (CK_SESSION_HANDLE)session_p;
-	(void) free(newTemplate);
-	bzero(key_buf, key_len);
-	(void) free(key_buf);
+	free(newTemplate);
+	freezero(key_buf, key_len);
 	return (CKR_OK);
 
 failed_exit:
 	free_attributes(obj_ngk.ngk_in_attributes, &obj_ngk.ngk_in_count);
 	free_attributes(obj_ngk.ngk_out_attributes, &obj_ngk.ngk_out_count);
-	if (key_buf != NULL) {
-		bzero(key_buf, key_len);
-		(void) free(key_buf);
-	}
-	if (newTemplate != NULL) {
-		(void) free(newTemplate);
-	}
+	freezero(key_buf, key_len);
+	free(newTemplate);
 	return (rv);
 }
 
